// This file was generated by gir (https://github.com/gtk-rs/gir)
// from
// from gir-files (https://github.com/gtk-rs/gir-files.git)
// DO NOT EDIT

use glib::{
    prelude::*,
    signal::{connect_raw, SignalHandlerId},
    translate::*,
};
use std::{boxed::Box as Box_, fmt, mem::transmute};

#[cfg(feature = "gtk_v3_4")]
#[cfg_attr(docsrs, doc(cfg(feature = "gtk_v3_4")))]
glib::wrapper! {
    #[doc(alias = "DzlMenuButton")]
    pub struct MenuButton(Object<ffi::DzlMenuButton, ffi::DzlMenuButtonClass>) @extends gtk::MenuButton, gtk::Button, gtk::Bin, gtk::Container, gtk::Widget, @implements gtk::Buildable, gtk::Actionable;

    match fn {
        type_ => || ffi::dzl_menu_button_get_type(),
    }
}

#[cfg(not(any(feature = "gtk_v3_4")))]
glib::wrapper! {
    #[doc(alias = "DzlMenuButton")]
    pub struct MenuButton(Object<ffi::DzlMenuButton, ffi::DzlMenuButtonClass>) @extends gtk::MenuButton, gtk::Button, gtk::Bin, gtk::Container, gtk::Widget, @implements gtk::Buildable;

    match fn {
        type_ => || ffi::dzl_menu_button_get_type(),
    }
}

impl MenuButton {
    pub const NONE: Option<&'static MenuButton> = None;

    #[doc(alias = "dzl_menu_button_new_with_model")]
    #[doc(alias = "new_with_model")]
    pub fn with_model(icon_name: &str, model: Option<&impl IsA<gio::MenuModel>>) -> MenuButton {
        assert_initialized_main_thread!();
        unsafe {
            gtk::Widget::from_glib_full(ffi::dzl_menu_button_new_with_model(
                icon_name.to_glib_none().0,
                model.map(|p| p.as_ref()).to_glib_none().0,
            ))
            .unsafe_cast()
        }
    }
}

mod sealed {
    pub trait Sealed {}
    impl<T: super::IsA<super::MenuButton>> Sealed for T {}
}

pub trait MenuButtonExt: IsA<MenuButton> + sealed::Sealed + 'static {
    #[cfg(feature = "v3_26")]
    #[cfg_attr(docsrs, doc(cfg(feature = "v3_26")))]
    #[doc(alias = "dzl_menu_button_get_model")]
    #[doc(alias = "get_model")]
    fn model(&self) -> Option<gio::MenuModel> {
        unsafe {
            from_glib_none(ffi::dzl_menu_button_get_model(
                self.as_ref().to_glib_none().0,
            ))
        }
    }

    #[doc(alias = "dzl_menu_button_get_show_accels")]
    #[doc(alias = "get_show_accels")]
    fn shows_accels(&self) -> bool {
        unsafe {
            from_glib(ffi::dzl_menu_button_get_show_accels(
                self.as_ref().to_glib_none().0,
            ))
        }
    }

    #[doc(alias = "dzl_menu_button_get_show_arrow")]
    #[doc(alias = "get_show_arrow")]
    fn shows_arrow(&self) -> bool {
        unsafe {
            from_glib(ffi::dzl_menu_button_get_show_arrow(
                self.as_ref().to_glib_none().0,
            ))
        }
    }

    #[doc(alias = "dzl_menu_button_get_show_icons")]
    #[doc(alias = "get_show_icons")]
    fn shows_icons(&self) -> bool {
        unsafe {
            from_glib(ffi::dzl_menu_button_get_show_icons(
                self.as_ref().to_glib_none().0,
            ))
        }
    }

    #[doc(alias = "dzl_menu_button_set_model")]
    fn set_model(&self, model: &impl IsA<gio::MenuModel>) {
        unsafe {
            ffi::dzl_menu_button_set_model(
                self.as_ref().to_glib_none().0,
                model.as_ref().to_glib_none().0,
            );
        }
    }

    #[cfg(feature = "v3_26")]
    #[cfg_attr(docsrs, doc(cfg(feature = "v3_26")))]
    #[doc(alias = "dzl_menu_button_set_show_accels")]
    fn set_show_accels(&self, show_accels: bool) {
        unsafe {
            ffi::dzl_menu_button_set_show_accels(
                self.as_ref().to_glib_none().0,
                show_accels.into_glib(),
            );
        }
    }

    #[cfg(feature = "v3_26")]
    #[cfg_attr(docsrs, doc(cfg(feature = "v3_26")))]
    #[doc(alias = "dzl_menu_button_set_show_arrow")]
    fn set_show_arrow(&self, show_arrow: bool) {
        unsafe {
            ffi::dzl_menu_button_set_show_arrow(
                self.as_ref().to_glib_none().0,
                show_arrow.into_glib(),
            );
        }
    }

    #[cfg(feature = "v3_26")]
    #[cfg_attr(docsrs, doc(cfg(feature = "v3_26")))]
    #[doc(alias = "dzl_menu_button_set_show_icons")]
    fn set_show_icons(&self, show_icons: bool) {
        unsafe {
            ffi::dzl_menu_button_set_show_icons(
                self.as_ref().to_glib_none().0,
                show_icons.into_glib(),
            );
        }
    }

    #[doc(alias = "icon-name")]
    fn set_icon_name(&self, icon_name: Option<&str>) {
        ObjectExt::set_property(self.as_ref(), "icon-name", icon_name)
    }

    #[cfg(feature = "v3_26")]
    #[cfg_attr(docsrs, doc(cfg(feature = "v3_26")))]
    #[doc(alias = "menu-id")]
    fn set_menu_id(&self, menu_id: Option<&str>) {
        ObjectExt::set_property(self.as_ref(), "menu-id", menu_id)
    }

    fn get_property_model(&self) -> Option<gio::MenuModel> {
        ObjectExt::property(self.as_ref(), "model")
    }

    #[doc(alias = "show-accels")]
    fn set_property_show_accels(&self, show_accels: bool) {
        ObjectExt::set_property(self.as_ref(), "show-accels", show_accels)
    }

    #[doc(alias = "show-arrow")]
    fn set_property_show_arrow(&self, show_arrow: bool) {
        ObjectExt::set_property(self.as_ref(), "show-arrow", show_arrow)
    }

    #[doc(alias = "show-icons")]
    fn set_property_show_icons(&self, show_icons: bool) {
        ObjectExt::set_property(self.as_ref(), "show-icons", show_icons)
    }

    #[doc(alias = "transitions-enabled")]
    fn is_transitions_enabled(&self) -> bool {
        ObjectExt::property(self.as_ref(), "transitions-enabled")
    }

    #[doc(alias = "transitions-enabled")]
    fn set_transitions_enabled(&self, transitions_enabled: bool) {
        ObjectExt::set_property(self.as_ref(), "transitions-enabled", transitions_enabled)
    }

    #[doc(alias = "icon-name")]
    fn connect_icon_name_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn notify_icon_name_trampoline<
            P: IsA<MenuButton>,
            F: Fn(&P) + 'static,
        >(
            this: *mut ffi::DzlMenuButton,
            _param_spec: glib::ffi::gpointer,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(MenuButton::from_glib_borrow(this).unsafe_cast_ref())
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::icon-name\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_icon_name_trampoline::<Self, F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }

    #[cfg(feature = "v3_26")]
    #[cfg_attr(docsrs, doc(cfg(feature = "v3_26")))]
    #[doc(alias = "menu-id")]
    fn connect_menu_id_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn notify_menu_id_trampoline<P: IsA<MenuButton>, F: Fn(&P) + 'static>(
            this: *mut ffi::DzlMenuButton,
            _param_spec: glib::ffi::gpointer,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(MenuButton::from_glib_borrow(this).unsafe_cast_ref())
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::menu-id\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_menu_id_trampoline::<Self, F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }

    #[doc(alias = "model")]
    fn connect_model_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn notify_model_trampoline<P: IsA<MenuButton>, F: Fn(&P) + 'static>(
            this: *mut ffi::DzlMenuButton,
            _param_spec: glib::ffi::gpointer,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(MenuButton::from_glib_borrow(this).unsafe_cast_ref())
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::model\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_model_trampoline::<Self, F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }

    #[doc(alias = "show-accels")]
    fn connect_show_accels_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn notify_show_accels_trampoline<
            P: IsA<MenuButton>,
            F: Fn(&P) + 'static,
        >(
            this: *mut ffi::DzlMenuButton,
            _param_spec: glib::ffi::gpointer,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(MenuButton::from_glib_borrow(this).unsafe_cast_ref())
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::show-accels\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_show_accels_trampoline::<Self, F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }

    #[doc(alias = "show-arrow")]
    fn connect_show_arrow_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn notify_show_arrow_trampoline<
            P: IsA<MenuButton>,
            F: Fn(&P) + 'static,
        >(
            this: *mut ffi::DzlMenuButton,
            _param_spec: glib::ffi::gpointer,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(MenuButton::from_glib_borrow(this).unsafe_cast_ref())
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::show-arrow\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_show_arrow_trampoline::<Self, F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }

    #[doc(alias = "show-icons")]
    fn connect_show_icons_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn notify_show_icons_trampoline<
            P: IsA<MenuButton>,
            F: Fn(&P) + 'static,
        >(
            this: *mut ffi::DzlMenuButton,
            _param_spec: glib::ffi::gpointer,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(MenuButton::from_glib_borrow(this).unsafe_cast_ref())
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::show-icons\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_show_icons_trampoline::<Self, F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }

    #[doc(alias = "transitions-enabled")]
    fn connect_transitions_enabled_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn notify_transitions_enabled_trampoline<
            P: IsA<MenuButton>,
            F: Fn(&P) + 'static,
        >(
            this: *mut ffi::DzlMenuButton,
            _param_spec: glib::ffi::gpointer,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(MenuButton::from_glib_borrow(this).unsafe_cast_ref())
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::transitions-enabled\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_transitions_enabled_trampoline::<Self, F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }
}

impl<O: IsA<MenuButton>> MenuButtonExt for O {}

impl fmt::Display for MenuButton {
    fn fmt(&self, f: &mut fmt::Formatter) -> fmt::Result {
        f.write_str("MenuButton")
    }
}
